]> arthur.barton.de Git - ngircd-alex.git/blob - autogen.sh
configure.ng: use AM_PROG_AR to check ar(1) command
[ngircd-alex.git] / autogen.sh
1 #!/bin/sh
2 #
3 # ngIRCd -- The Next Generation IRC Daemon
4 # Copyright (c)2001-2012 Alexander Barton (alex@barton.de) and Contributors
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12 # Usage:
13 #   [VAR=<value>] ./autogen.sh [<configure-args>]
14 #
15 # This script generates the ./configure script using GNU automake and
16 # GNU autoconf. It tries to be smart in finding the correct/usable/available
17 # installed versions of these tools on your system.
18 #
19 # In addition, it enables or disables the "de-ANSI-fication" support of GNU
20 # automake, which is supported up to autoconf 1.11.x an has been removed
21 # in automake 1.12 -- make sure to use a version of automake supporting it
22 # when generating distribution archives!
23 #
24 # The following strategy is used for each of aclocal, autoheader, automake,
25 # and autoconf: first, "tool" (the regular name of the tool, e. g. "autoconf"
26 # or "automake") is checked. If this fails, "tool<major><minor>" (for example
27 # "automake16") and "tool-<major>.<minor>" (e. g. "autoconf-2.54") are tried
28 # with <major> being 2 for tool of GNU autoconf and 1 for tools of automake;
29 # <minor> is tried from 99 to 0. The first occurrence will be used.
30 #
31 # When you pass <configure-args> to autogen.sh it will call the generated
32 # ./configure script on success and pass these parameters to it.
33 #
34 # You can tweak the behaviour using these environment variables:
35 #
36 # - ACLOCAL=<cmd>, AUTOHEADER=<cmd>, AUTOMAKE=<cmd>, AUTOCONF=<cmd>
37 #   Name and optionally path to the particular tool.
38 # - PREFIX=<path>
39 #   Search the GNU autoconf and GNU automake tools in <path> first. If the
40 #   generated ./configure script will be called, pass "--prefix=<path>" to it.
41 # - EXIST=<tool>
42 #   Use <tool> to test for aclocal, autoheader etc. pp. ...
43 #   When not specified, either "type" or "which" is used.
44 # - VERBOSE=1
45 #   Output the detected names of the GNU automake and GNU autoconf tools.
46 # - GO=1
47 #   Call ./configure even if no arguments have been passed to autogen.sh.
48 #
49 # Examples:
50 #
51 # - ./autogen.sh
52 #   Generates the ./configure script.
53 # - GO=1 ./autogen.sh
54 #   Generates the ./configure script and runs it as "./configure".
55 # - VERBOSE=1 ./autogen.sh --with-ident
56 #   Show tool names, generates the ./configure script, and runs it with
57 #   these arguments: "./configure --with-ident".
58 # - ACLOCAL=aclocal-1.6 GO=1 PREFIX=$HOME ./autogen.sh
59 #   Uses "aclocal-1.6" as aclocal tool, generates the ./configure script,
60 #   and runs it with these arguments: "./configure --prefix=$HOME".
61 #
62
63 Search()
64 {
65         [ $# -eq 2 ] || exit 1
66
67         searchlist="$1"
68         major="$2"
69         minor=99
70
71         [ -n "$PREFIX" ] && searchlist="${PREFIX}/$1 ${PREFIX}/bin/$1 $searchlist"
72
73         for name in $searchlist; do
74                 $EXIST "${name}" >/dev/null 2>&1
75                 if [ $? -eq 0 ]; then
76                         echo "${name}"
77                         return 0
78                 fi
79         done
80
81         while [ $minor -ge 0 ]; do
82                 for name in $searchlist; do
83                         $EXIST "${name}${major}${minor}" >/dev/null 2>&1
84                         if [ $? -eq 0 ]; then
85                                 echo "${name}${major}${minor}"
86                                 return 0
87                         fi
88                         $EXIST "${name}-${major}.${minor}" >/dev/null 2>&1
89                         if [ $? -eq 0 ]; then
90                                 echo "${name}-${major}.${minor}"
91                                 return 0
92                         fi
93                 done
94                 minor=`expr $minor - 1`
95         done
96         return 1
97 }
98
99 Notfound()
100 {
101         echo "Error: $* not found!"
102         echo "Please install recent versions of GNU autoconf and GNU automake."
103         exit 1
104 }
105
106 Run()
107 {
108         [ "$VERBOSE" = "1" ] && echo " - running \"$@\" ..."
109         $@
110 }
111
112 # Reset locale settings to suppress warning messages of Perl
113 unset LC_ALL
114 unset LANG
115
116 # Which command should be used to detect the automake/autoconf tools?
117 [ -z "$EXIST" ] && existlist="type which" || existlist="$EXIST"
118 EXIST=""
119 for t in $existlist; do
120         $t /bin/ls >/dev/null 2>&1
121         if [ $? -eq 0 ]; then
122                 rm -f /tmp/test.$$
123                 $t /tmp/test.$$ >/dev/null 2>&1
124                 [ $? -ne 0 ] && EXIST="$t"
125         fi
126         [ -n "$EXIST" ] && break
127 done
128 if [ -z "$EXIST" ]; then
129         echo "Didn't detect a working command to test for the autoconf/automake tools!"
130         echo "Searchlist: $existlist"
131         exit 1
132 fi
133 [ "$VERBOSE" = "1" ] && echo "Using \"$EXIST\" to test for tools."
134
135 # Try to detect the needed tools when no environment variable already
136 # specifies one:
137 echo "Searching for required tools ..."
138 [ -z "$ACLOCAL" ] && ACLOCAL=`Search aclocal 1`
139 [ "$VERBOSE" = "1" ] && echo " - ACLOCAL=$ACLOCAL"
140 [ -z "$AUTOHEADER" ] && AUTOHEADER=`Search autoheader 2`
141 [ "$VERBOSE" = "1" ] && echo " - AUTOHEADER=$AUTOHEADER"
142 [ -z "$AUTOMAKE" ] && AUTOMAKE=`Search automake 1`
143 [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE=$AUTOMAKE"
144 [ -z "$AUTOCONF" ] && AUTOCONF=`Search autoconf 2`
145 [ "$VERBOSE" = "1" ] && echo " - AUTOCONF=$AUTOCONF"
146
147 [ $# -gt 0 ] && CONFIGURE_ARGS=" $@" || CONFIGURE_ARGS=""
148 [ -z "$GO" -a -n "$CONFIGURE_ARGS" ] && GO=1
149
150 # Verify that all tools have been found
151 [ -z "$ACLOCAL" ] && Notfound aclocal
152 [ -z "$AUTOHEADER" ] && Notfound autoheader
153 [ -z "$AUTOMAKE" ] && Notfound automake
154 [ -z "$AUTOCONF" ] && Notfound autoconf
155
156 AM_VERSION=`$AUTOMAKE --version|head -n 1|egrep -o "([1-9]\.[0-9]+(\.[0-9]+)*)"`
157 ifs=$IFS; IFS="."; set $AM_VERSION; IFS=$ifs
158 AM_MAJOR="$1"; AM_MINOR="$2"; AM_PATCHLEVEL="$3"
159
160 AM_MAKEFILES="src/ipaddr/Makefile.ng src/ngircd/Makefile.ng src/testsuite/Makefile.ng src/tool/Makefile.ng"
161
162 if [ "$AM_MAJOR" -eq "1" -a "$AM_MINOR" -lt "12" ]; then
163         # automake < 1.12 => automatic de-ANSI-fication support available
164         echo "Enabling de-ANSI-fication support (automake $AM_VERSION) ..."
165         sed -e "s|^__ng_PROTOTYPES__|AM_C_PROTOTYPES|g" configure.ng >configure.in
166         DEANSI_START=""
167         DEANSI_END=""
168 else
169         # automake >= 1.12 => no de-ANSI-fication support available
170         echo "Disabling de-ANSI-fication support (automake $AM_VERSION) ..."
171         sed -e "s|^__ng_PROTOTYPES__|AC_C_PROTOTYPES|g" configure.ng >configure.in
172         DEANSI_START="#"
173         DEANSI_END="    # disabled by ./autogen.sh script"
174 fi
175 sed -e "s|^__ng_Makefile_am_template__|${DEANSI_START}AUTOMAKE_OPTIONS = ansi2knr${DEANSI_END}|g" \
176         src/portab/Makefile.ng >src/portab/Makefile.am
177 for makefile_ng in $AM_MAKEFILES; do
178         makefile_am=`echo "$makefile_ng" | sed -e "s|\.ng\$|\.am|g"`
179         sed -e "s|^__ng_Makefile_am_template__|${DEANSI_START}AUTOMAKE_OPTIONS = ../portab/ansi2knr${DEANSI_END}|g" \
180                 $makefile_ng >$makefile_am
181 done
182
183 export ACLOCAL AUTOHEADER AUTOMAKE AUTOCONF
184
185 # Generate files
186 echo "Generating files using GNU $AUTOCONF and $AUTOMAKE ..."
187 Run $ACLOCAL && \
188         Run $AUTOCONF && \
189         Run $AUTOHEADER && \
190         Run $AUTOMAKE --add-missing --no-force
191
192 if [ $? -eq 0 -a -x ./configure ]; then
193         # Success: if we got some parameters we call ./configure and pass
194         # all of them to it.
195         NAME=`grep PACKAGE_STRING= configure | cut -d"'" -f2`
196         if [ "$GO" = "1" ]; then
197                 [ -n "$PREFIX" ] && p=" --prefix=$PREFIX" || p=""
198                 c="./configure${p}${CONFIGURE_ARGS}"
199                 echo "Okay, autogen.sh for $NAME done."
200                 echo "Calling \"$c\" ..."
201                 $c
202                 exit $?
203         else
204                 echo "Okay, autogen.sh for $NAME done."
205                 echo "Now run the \"./configure\" script."
206                 exit 0
207         fi
208 else
209         # Failure!?
210         echo "Error! Check your installation of GNU automake and autoconf!"
211         exit 1
212 fi
213
214 # -eof-